Index: main/manager.c
===================================================================
--- main/manager.c	(revision 148468)
+++ main/manager.c	(working copy)
@@ -3845,42 +4075,380 @@
 			blastaway = 1;
 		} else {
 			ast_debug(1, "Need destroy, but can't do it yet!\n");
-			if (s->waiting_thread != AST_PTHREADT_NULL)
+			if (s->waiting_thread != AST_PTHREADT_NULL) {
 				pthread_kill(s->waiting_thread, SIGURG);
+			}
 			s->inuse--;
 		}
-	} else
+	} else {
 		s->inuse--;
-	ast_mutex_unlock(&s->__lock);
+	}
+	ao2_unlock(s);
 
-	if (blastaway)
-		destroy_session(s);
+	ast_http_send(ser, method, 200, NULL, http_header, out, 0, 0);
+	http_header = out = NULL;
+
 generic_callback_out:
-	if (*status != 200)
-		return ast_http_error(500, "Server Error", NULL, "Internal Server Error (out of memory)\n");
-	return out;
+	/* Clear resource */
+
+	if (method == AST_HTTP_POST && params) {
+		ast_variables_destroy(params);
+	}
+	if (http_header) {
+		ast_free(http_header);
+	}
+	if (out) {
+		ast_free(out);
+	}
+	if(s->f) {
+		fclose(s->f);
+	}
+
+	if (s != NULL && blastaway) {
+		session_destroy(s);
+	}
+	return 0;
 }
 
-static struct ast_str *manager_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *params, struct ast_variable *headers, int *status, char **title, int *contentlength)
+static int auth_http_callback(struct ast_tcptls_session_instance *ser,
+					     enum ast_http_method method,
+					     enum output_format format,
+					     struct sockaddr_in *requestor, const char *uri,
+					     struct ast_variable *get_params,
+					     struct ast_variable *headers)
 {
-	return generic_http_callback(FORMAT_HTML, &ser->requestor, uri, method, params, status, title, contentlength);
+	struct mansession *s = NULL;
+	struct ast_variable *v, *params = get_params;
+	char template[] = "/tmp/ast-http-XXXXXX";	/* template for temporary file */
+	struct ast_str *http_header = NULL, *out = NULL;
+	size_t result_size = 0;
+	struct message m = { 0 };
+	unsigned int x;
+	size_t hdrlen;
+
+	time_t time_now = time(NULL);
+	unsigned long nonce = 0, nc;
+	struct ast_http_digest d;
+	struct ast_manager_user *user = NULL;
+	int stale = 0;
+	char resp_hash[256]="";
+	/* Cache for user data */
+	char u_username[80];
+	int u_readperm;
+	int u_writeperm;
+	int u_writetimeout;
+	int u_displayconnects;
+
+	if (method != AST_HTTP_GET && method != AST_HTTP_HEAD && method != AST_HTTP_POST) {
+		ast_http_error(ser, 501, "Not Implemented", "Attempt to use unimplemented / unsupported method");
+		return -1;
+	}
+	
+	/* Find "Authorization: " header */
+	for (v = headers; v; v = v->next) {
+		if (!strcasecmp(v->name, "Authorization")) {
+			break;
+		}
+	}
+
+	if (!v || ast_strlen_zero(v->value)) {
+		goto out_401; /* Authorization Header not present - send auth request */
+	}
+	
+	/* Digest found - parse */
+	if (ast_parse_digest(v->value, &d, 0, 1)) {
+		/* Error in Digest - send new one */
+		nonce = 0;
+		goto out_401;
+	}
+	if (sscanf(d.nonce, "%lx", &nonce) != 1) {
+		ast_log(LOG_WARNING, "Received incorrect nonce in Digest <%s>\n", d.nonce);
+		nonce = 0;
+		goto out_401;
+	}
+	
+	AST_RWLIST_WRLOCK(&users);
+	user = get_manager_by_name_locked(d.username);
+	if(!user) {
+		AST_RWLIST_UNLOCK(&users);
+		ast_log(LOG_NOTICE, "%s tried to authenticate with nonexistent user '%s'\n", ast_inet_ntoa(requestor->sin_addr), d.username);
+		nonce = 0;
+		goto out_401;
+	}
+
+	/* --- We have User for this auth, now check ACL */
+	if (user->ha && !ast_apply_ha(user->ha, requestor)) {
+		AST_RWLIST_UNLOCK(&users);
+		ast_log(LOG_NOTICE, "%s failed to pass IP ACL as '%s'\n", ast_inet_ntoa(requestor->sin_addr), d.username);
+		ast_http_error(ser, 403, "Permission denied", "Permission denied\n");
+		return -1;
+	}
+	
+	/* --- We have auth, so check it */
+
+	/* compute the expected response to compare with what we received */
+	{
+		char a2[256];
+		char a2_hash[256];
+		char resp[256];
+
+		/* XXX Now request method are hardcoded in A2 */
+		snprintf(a2, sizeof(a2), "%s:%s", ast_get_http_method(method), d.uri);
+		ast_md5_hash(a2_hash, a2);
+		
+		if (d.qop) {
+			/* RFC 2617 */	
+			snprintf(resp, sizeof(resp), "%s:%08lx:%s:%s:auth:%s", user->a1_hash, nonce, d.nc, d.cnonce, a2_hash);
+		}  else {
+			/* RFC 2069 */
+			snprintf(resp, sizeof(resp), "%s:%08lx:%s", user->a1_hash, nonce, a2_hash);
+		}
+		ast_md5_hash(resp_hash, resp);
+	}
+	
+	if (!d.nonce  || strncasecmp(d.response, resp_hash, strlen(resp_hash))) {
+		/* Something was wrong, so give the client to try with a new challenge */
+		AST_RWLIST_UNLOCK(&users);
+		nonce = 0;
+		goto out_401;
+	}
+
+	/*
+	 * User are pass Digest authentication.
+	 * Now, cache the user data and unlock user list.
+	 */
+	strncpy(u_username, user->username, sizeof(u_username)-1);
+	u_readperm = user->readperm;
+	u_writeperm = user->writeperm;
+	u_displayconnects = user->displayconnects;
+	AST_RWLIST_UNLOCK(&users);
+
+	if (!(s = find_session_by_nonce(d.username, nonce, &stale))) {
+		
+		if (num_sessions >= MAX_SESSIONS) {
+			/* Limit the active session numbers */
+			ast_http_error(ser, 500, "Server Error", "Internal Server Error (to many connections)\n");
+			return -1;
+		}
+		
+		/*
+		 * Create new session.
+		 * While it is not in the list we don't need any locking
+		 */
+		if (!(s = build_mansession(*requestor))) {
+			ast_http_error(ser, 500, "Server Error", "Internal Server Error (out of memory)\n");
+			return -1;
+		}
+		ao2_lock(s);
+
+		ast_copy_string(s->username, u_username, sizeof(s->username));
+		s->managerid = nonce;
+		s->last_ev = grab_last();
+		AST_LIST_HEAD_INIT_NOLOCK(&s->datastores);
+
+		s->readperm = u_readperm;
+		s->writeperm = u_writeperm;
+		s->writetimeout = u_writetimeout;
+
+		if (u_displayconnects) {
+			ast_verb(2, "HTTP Manager '%s' logged in from %s\n", s->username, ast_inet_ntoa(s->sin.sin_addr));
+		}
+		s->noncetime = s->sessionstart = time_now;
+		s->authenticated = 1;
+		
+		ast_log(LOG_EVENT, "HTTP Manager '%s' logged in from %s\n", s->username, ast_inet_ntoa(s->sin.sin_addr));
+
+	} else if(stale) {
+		/*
+		 * Session found, but nonce is staled.
+		 *
+		 * It may be caused if old request (w/old nonce) arrived.
+		 * 
+		 * Or, if http request with lower nonce_count value
+		 * arrive after request w/higher nonce counter and
+		 * new auth request was beed send before.
+		 * 
+		 * This may be as the result of http proxy usage 
+		 * (separate delay or multipath) or in situation,
+		 * if page are refreshed to fast (found in Firefox).
+		 *
+		 * In this situation reask the auth information with
+		 * actual nonce value.
+		 */
+		nonce = s->managerid;
+		ao2_unlock(s);
+		stale = 1;
+		goto out_401;
+	} else {
+		sscanf(d.nc, "%lx", &nc);
+		if (s->nc >= nc || ((time_now - s->noncetime) > 62) ) {
+			/*
+			 * Nonce time expired (> 2 minutes)
+			 * or something wrong with nonce counter.
+			 *
+			 * Create new nonce key, put him in managerid field
+			 * in manager session struct and resend Digest auth
+			 * request.
+			 * Save expired nonce value in s->oldnonce field for
+			 * stale checking...
+			 */
+			s->nc = 0; /* Reset nonce counter */
+			s->oldnonce = s->managerid;
+			nonce = s->managerid = ast_random();
+			s->noncetime = time_now;
+			ao2_lock(s);
+			stale = 1;
+			goto out_401;
+		} else {
+			s->nc = nc; /* All OK, save nonce counter */
+		}
+	}
+
+
+	/* Reset session timeout. */
+	s->sessiontimeout = time(NULL) + (httptimeout > 5 ? httptimeout : 5);
+	ao2_unlock(s);
+
+	s->fd = mkstemp(template);	/* create a temporary file for command output */
+	unlink(template);
+	if (s->fd <= -1) {
+		ast_http_error(ser, 500, "Server Error", "Internal Server Error (mkstemp failed)\n");
+		goto auth_callback_out;
+	}
+	s->f = fdopen(s->fd, "w+");
+	if (!s->f) {
+		ast_log(LOG_WARNING, "HTTP Manager, fdopen failed: %s!\n", strerror(errno));
+		ast_http_error(ser, 500, "Server Error", "Internal Server Error (fdopen failed)\n");
+		goto auth_callback_out;
+	}
+	
+	if (method == AST_HTTP_POST) {
+		params = get_post_vars(ser, headers);
+	}
+
+	for (x=0, v = params; v && (x < AST_MAX_MANHEADERS); x++, v = v->next) {
+		hdrlen = strlen(v->name) + strlen(v->value) + 3;
+		m.headers[m.hdrcount] = alloca(hdrlen);
+		snprintf((char *) m.headers[m.hdrcount], hdrlen, "%s: %s", v->name, v->value);
+		ast_verb(4, "HTTP Manager add header %s\n", m.headers[m.hdrcount]);
+		m.hdrcount = x + 1;
+	}
+
+	if (process_message(s, &m)) {
+		if (u_displayconnects) {
+			ast_verb(2, "HTTP Manager '%s' logged off from %s\n", s->username, ast_inet_ntoa(s->sin.sin_addr));
+		}
+		ast_log(LOG_EVENT, "HTTP Manager '%s' logged off from %s\n", s->username, ast_inet_ntoa(s->sin.sin_addr));
+
+		s->needdestroy = 1;
+	}
+
+	if (s->f) {
+		result_size = ftell(s->f); /* Calculate aprox. size of result */
+	}
+
+	http_header = ast_str_create(80);
+	out = ast_str_create(result_size * 2 + 512);
+
+	if (http_header == NULL || out == NULL) {
+		ast_http_error(ser, 500, "Server Error", "Internal Server Error (ast_str_create() out of memory)\n");
+		goto auth_callback_out;
+	}
+
+	ast_str_append(&http_header, 0, "Content-type: text/%s", contenttype[format]);
+
+	if (format == FORMAT_XML) {
+		ast_str_append(&out, 0, "<ajax-response>\n");
+	} else if (format == FORMAT_HTML) {
+		ast_str_append(&out, 0,
+		"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\r\n"
+		"<html><head>\r\n"
+		"<title>Asterisk&trade; Manager Interface</title>\r\n"
+		"</head><body style=\"background-color: #ffffff;\">\r\n"
+		"<form method=\"POST\">\r\n"
+		"<table align=\"center\" style=\"background-color: #f1f1f1;\" width=\"500\">\r\n"
+		"<tr><th colspan=\"2\" style=\"background-color: #f1f1ff;\"><h1>Manager Tester</h1></th></tr>\r\n"
+		"<tr><th colspan=\"2\" style=\"background-color: #f1f1ff;\">Action: <input name=\"action\" /> Cmd: <input name=\"command\" /><br>"
+		"<input type=\"submit\" value=\"Send request\" /></th></tr>\r\n");
+	}
+		
+	if (result_size) {
+		char *buf;
+		if ((buf = mmap(NULL, result_size, PROT_READ | PROT_WRITE, MAP_SHARED, s->fd, 0))) {
+			if (format == FORMAT_XML || format == FORMAT_HTML) {
+				xml_translate(&out, buf, params, format);
+			} else {
+				ast_str_append(&out, 0, "%s", buf);
+			}
+			munmap(buf, result_size);
+		}
+	} else if (format == FORMAT_XML || format == FORMAT_HTML) {
+		xml_translate(&out, "", params, format);
+	}
+
+	if (format == FORMAT_XML) {
+		ast_str_append(&out, 0, "</ajax-response>\n");
+	} else if (format == FORMAT_HTML) {
+		ast_str_append(&out, 0, "</table></form></body></html>\r\n");
+	}
+	
+	ast_http_send(ser, method, 200, NULL, http_header, out, 0, 0);
+	http_header = out = NULL;
+		
+auth_callback_out:
+	/* Clear resource and unlock manager session */
+	if (method == AST_HTTP_POST && params) {
+		ast_variables_destroy(params);
+	}
+	if (http_header) {
+		ast_free(http_header);
+	}
+	if (out) {
+		ast_free(out);
+	}
+
+	ao2_lock(s);
+	if(s->f) {
+		fclose(s->f);
+	}
+	s->f = NULL;
+	s->fd = -1;
+	ao2_unlock(s);
+
+	if (s->needdestroy) {
+		ast_debug(1, "Need destroy, doing it now!\n");
+		session_destroy(s);
+	}
+	return 0;
+	
+out_401:
+	if (!nonce) {
+		nonce = ast_random();
+	}
+	
+	ast_http_auth(ser, global_realm, nonce, nonce, stale, NULL);
+	return 0;
 }
 
-static struct ast_str *mxml_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *params, struct ast_variable *headers, int *status, char **title, int *contentlength)
+static int manager_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *get_params,  struct ast_variable *headers)
 {
-	return generic_http_callback(FORMAT_XML, &ser->requestor, uri, method, params, status, title, contentlength);
+	return generic_http_callback(ser, method, FORMAT_HTML, &ser->requestor, uri, get_params, headers);
 }
 
-static struct ast_str *rawman_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *params, struct ast_variable *headers, int *status, char **title, int *contentlength)
+static int mxml_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *get_params, struct ast_variable *headers)
 {
-	return generic_http_callback(FORMAT_RAW, &ser->requestor, uri, method, params, status, title, contentlength);
+	return generic_http_callback(ser, method, FORMAT_XML, &ser->requestor, uri, get_params, headers);
 }
 
+static int rawman_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *get_params, struct ast_variable *headers)
+{
+	return generic_http_callback(ser, method, FORMAT_RAW, &ser->requestor, uri, get_params, headers);
+}
+
 struct ast_http_uri rawmanuri = {
 	.description = "Raw HTTP Manager Event Interface",
 	.uri = "rawman",
 	.callback = rawman_http_callback,
-	.supports_get = 1,
 	.data = NULL,
 	.key = __FILE__,
 };
@@ -3889,7 +4457,6 @@
 	.description = "HTML Manager Event Interface",
 	.uri = "manager",
 	.callback = manager_http_callback,
-	.supports_get = 1,
 	.data = NULL,
 	.key = __FILE__,
 };
@@ -3898,11 +4465,54 @@
 	.description = "XML Manager Event Interface",
 	.uri = "mxml",
 	.callback = mxml_http_callback,
-	.supports_get = 1,
 	.data = NULL,
 	.key = __FILE__,
 };
 
+
+/* Callback with Digest authentication */
+static int auth_manager_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *get_params,  struct ast_variable *headers)
+{
+	return auth_http_callback(ser, method, FORMAT_HTML, &ser->requestor, uri, get_params, headers);
+}
+
+static int auth_mxml_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *get_params, struct ast_variable *headers)
+{
+	return auth_http_callback(ser, method, FORMAT_XML, &ser->requestor, uri, get_params, headers);
+}
+
+static int auth_rawman_http_callback(struct ast_tcptls_session_instance *ser, const struct ast_http_uri *urih, const char *uri, enum ast_http_method method, struct ast_variable *get_params, struct ast_variable *headers)
+{
+	return auth_http_callback(ser, method, FORMAT_RAW, &ser->requestor, uri, get_params, headers);
+}
+
+struct ast_http_uri arawmanuri = {
+	.description = "Raw HTTP Manager Event Interface w/Digest authentication",
+	.uri = "arawman",
+	.has_subtree = 0,
+	.callback = auth_rawman_http_callback,
+	.data = NULL,
+	.key = __FILE__,
+};
+
+struct ast_http_uri amanageruri = {
+	.description = "HTML Manager Event Interface w/Digest authentication",
+	.uri = "amanager",
+	.has_subtree = 0,
+	.callback = auth_manager_http_callback,
+	.data = NULL,
+	.key = __FILE__,
+};
+
+struct ast_http_uri amanagerxmluri = {
+	.description = "XML Manager Event Interface w/Digest authentication",
+	.uri = "amxml",
+	.has_subtree = 0,
+	.callback = auth_mxml_http_callback,
+	.data = NULL,
+	.key = __FILE__,
+};
+
 static int registered = 0;
 static int webregged = 0;
 
@@ -3949,6 +4559,8 @@
 	struct ast_manager_user *user = NULL;
 	struct ast_variable *var;
 	struct ast_flags config_flags = { reload ? CONFIG_FLAG_FILEUNCHANGED : 0 };
+	char a1[256];
+	char a1_hash[256];
 
 	manager_enabled = 0;
 
@@ -3993,8 +4605,9 @@
 		/* Append placeholder event so master_eventq never runs dry */
 		append_event("Event: Placeholder\r\n\r\n", 0);
 	}
-	if ((cfg = ast_config_load2("manager.conf", "manager", config_flags)) == CONFIG_STATUS_FILEUNCHANGED)
+	if ((cfg = ast_config_load2("manager.conf", "manager", config_flags)) == CONFIG_STATUS_FILEUNCHANGED) {
 		return 0;
+	}
 
 	displayconnects = 1;
 	if (!cfg) {
@@ -4003,26 +4616,29 @@
 	}
 
 	/* default values */
+	ast_copy_string(global_realm, S_OR(ast_config_AST_SYSTEM_NAME, DEFAULT_REALM), sizeof(global_realm));
 	memset(&ami_desc.sin, 0, sizeof(struct sockaddr_in));
 	memset(&amis_desc.sin, 0, sizeof(amis_desc.sin));
 	amis_desc.sin.sin_port = htons(5039);
 	ami_desc.sin.sin_port = htons(DEFAULT_MANAGER_PORT);
 
 	ami_tls_cfg.enabled = 0;
-	if (ami_tls_cfg.certfile)
+	if (ami_tls_cfg.certfile) {
 		ast_free(ami_tls_cfg.certfile);
+	}
 	ami_tls_cfg.certfile = ast_strdup(AST_CERTFILE);
-	if (ami_tls_cfg.cipher)
+	if (ami_tls_cfg.cipher) {
 		ast_free(ami_tls_cfg.cipher);
+	}
 	ami_tls_cfg.cipher = ast_strdup("");
 
 	for (var = ast_variable_browse(cfg, "general"); var; var = var->next) {
 		val = var->value;
-		if (!strcasecmp(var->name, "sslenable"))
+		if (!strcasecmp(var->name, "sslenable")) {
 			ami_tls_cfg.enabled = ast_true(val);
-		else if (!strcasecmp(var->name, "sslbindport"))
+		} else if (!strcasecmp(var->name, "sslbindport")) {
 			amis_desc.sin.sin_port = htons(atoi(val));
-		else if (!strcasecmp(var->name, "sslbindaddr")) {
+		} else if (!strcasecmp(var->name, "sslbindaddr")) {
 			if ((hp = ast_gethostbyname(val, &ahp))) {
 				memcpy(&amis_desc.sin.sin_addr, hp->h_addr, sizeof(amis_desc.sin.sin_addr));
 				have_sslbindaddr = 1;
@@ -4064,12 +4680,15 @@
 		}	
 	}
 
-	if (manager_enabled)
+	if (manager_enabled) {
 		ami_desc.sin.sin_family = AF_INET;
-	if (!have_sslbindaddr)
+	}
+	if (!have_sslbindaddr) {
 		amis_desc.sin.sin_addr = ami_desc.sin.sin_addr;
-	if (ami_tls_cfg.enabled)
+	}
+	if (ami_tls_cfg.enabled) {
 		amis_desc.sin.sin_family = AF_INET;
+	}
 
 	
 	AST_RWLIST_WRLOCK(&users);
@@ -4081,8 +4700,9 @@
 		int genhasmanager = ast_true(ast_variable_retrieve(ucfg, "general", "hasmanager"));
 
 		while ((cat = ast_category_browse(ucfg, cat))) {
-			if (!strcasecmp(cat, "general"))
+			if (!strcasecmp(cat, "general")) {
 				continue;
+			}
 			
 			hasmanager = ast_variable_retrieve(ucfg, cat, "hasmanager");
 			if ((!hasmanager && genhasmanager) || ast_true(hasmanager)) {
@@ -4096,8 +4716,9 @@
 				 * if none found - create one and add it to the list
 				 */
 				if (!(user = get_manager_by_name_locked(cat))) {
-					if (!(user = ast_calloc(1, sizeof(*user))))
+					if (!(user = ast_calloc(1, sizeof(*user)))) {
 						break;
+					}
 
 					/* Copy name over */
 					ast_copy_string(user->username, cat, sizeof(user->username));
@@ -4112,36 +4733,45 @@
 					user->writetimeout = 100;
 				}
 
-				if (!user_secret)
+				if (!user_secret) {
 					user_secret = ast_variable_retrieve(ucfg, "general", "secret");
-				if (!user_read)
+				}
+				if (!user_read) {
 					user_read = ast_variable_retrieve(ucfg, "general", "read");
-				if (!user_write)
+				}
+				if (!user_write) {
 					user_write = ast_variable_retrieve(ucfg, "general", "write");
-				if (!user_displayconnects)
+				}
+				if (!user_displayconnects) {
 					user_displayconnects = ast_variable_retrieve(ucfg, "general", "displayconnects");
-				if (!user_writetimeout)
+				}
+				if (!user_writetimeout) {
 					user_writetimeout = ast_variable_retrieve(ucfg, "general", "writetimeout");
+				}
 
 				if (!ast_strlen_zero(user_secret)) {
-					if (user->secret)
+					if (user->secret) {
 						ast_free(user->secret);
+					}
 					user->secret = ast_strdup(user_secret);
 				}
 
-				if (user_read)
+				if (user_read) {
 					user->readperm = get_perm(user_read);
-				if (user_write)
+				}
+				if (user_write) {
 					user->writeperm = get_perm(user_write);
-				if (user_displayconnects)
+				}
+				if (user_displayconnects) {
 					user->displayconnects = ast_true(user_displayconnects);
-
+				}
 				if (user_writetimeout) {
 					int value = atoi(user_writetimeout);
-					if (value < 100)
+					if (value < 100) {
 						ast_log(LOG_WARNING, "Invalid writetimeout value '%s' at users.conf line %d\n", var->value, var->lineno);
-					else
+					} else {
 						user->writetimeout = value;
+					}
 				}
 			}
 		}
@@ -4153,13 +4783,15 @@
 	while ((cat = ast_category_browse(cfg, cat))) {
 		struct ast_ha *oldha;
 
-		if (!strcasecmp(cat, "general"))
+		if (!strcasecmp(cat, "general")) {
 			continue;
+		}
 
 		/* Look for an existing entry, if none found - create one and add it to the list */
 		if (!(user = get_manager_by_name_locked(cat))) {
-			if (!(user = ast_calloc(1, sizeof(*user))))
+			if (!(user = ast_calloc(1, sizeof(*user)))) {
 				break;
+			}
 			/* Copy name over */
 			ast_copy_string(user->username, cat, sizeof(user->username));
 
@@ -4182,8 +4814,9 @@
 		var = ast_variable_browse(cfg, cat);
 		for (; var; var = var->next) {
 			if (!strcasecmp(var->name, "secret")) {
-				if (user->secret)
+				if (user->secret) {
 					ast_free(user->secret);
+				}
 				user->secret = ast_strdup(var->value);
 			} else if (!strcasecmp(var->name, "deny") ||
 				       !strcasecmp(var->name, "permit")) {
@@ -4196,12 +4829,14 @@
 				user->displayconnects = ast_true(var->value);
 			} else if (!strcasecmp(var->name, "writetimeout")) {
 				int value = atoi(var->value);
-				if (value < 100)
+				if (value < 100) {
 					ast_log(LOG_WARNING, "Invalid writetimeout value '%s' at line %d\n", var->value, var->lineno);
-				else
+				} else {
 					user->writetimeout = value;
-			} else
+				}
+			} else {
 				ast_debug(1, "%s is an unknown option.\n", var->name);
+			}
 		}
 		ast_free_ha(oldha);
 	}
@@ -4211,13 +4846,25 @@
 	AST_RWLIST_TRAVERSE_SAFE_BEGIN(&users, user, list) {
 		if (user->keep) {	/* valid record. clear flag for the next round */
 			user->keep = 0;
+			
+			/* Calculate A1 for Digest auth */
+			snprintf(a1, sizeof(a1), "%s:%s:%s", user->username, global_realm, user->secret);
+			ast_md5_hash(a1_hash,a1);
+			if (user->a1_hash) {
+				ast_free(user->a1_hash);
+			}
+			user->a1_hash = ast_strdup(a1_hash);
 			continue;
 		}
 		/* We do not need to keep this user so take them out of the list */
 		AST_RWLIST_REMOVE_CURRENT(list);
 		/* Free their memory now */
-		if (user->secret)
+		if (user->a1_hash) {
+			ast_free(user->a1_hash);
+		}
+		if (user->secret) {
 			ast_free(user->secret);
+		}
 		ast_free_ha(user->ha);
 		ast_free(user);
 	}
@@ -4225,11 +4872,20 @@
 
 	AST_RWLIST_UNLOCK(&users);
 
+	if (!reload) {
+		sessions = ao2_container_alloc(100, NULL, mansession_cmp_fn);
+	}
+
 	if (webmanager_enabled && manager_enabled) {
 		if (!webregged) {
+
 			ast_http_uri_link(&rawmanuri);
 			ast_http_uri_link(&manageruri);
 			ast_http_uri_link(&managerxmluri);
+			
+			ast_http_uri_link(&arawmanuri);
+			ast_http_uri_link(&amanageruri);
+			ast_http_uri_link(&amanagerxmluri);
 			webregged = 1;
 		}
 	} else {
@@ -4237,18 +4893,24 @@
 			ast_http_uri_unlink(&rawmanuri);
 			ast_http_uri_unlink(&manageruri);
 			ast_http_uri_unlink(&managerxmluri);
+
+			ast_http_uri_unlink(&arawmanuri);
+			ast_http_uri_unlink(&amanageruri);
+			ast_http_uri_unlink(&amanagerxmluri);
 			webregged = 0;
 		}
 	}
 
-	if (newhttptimeout > 0)
+	if (newhttptimeout > 0) {
 		httptimeout = newhttptimeout;
+	}
 
 	manager_event(EVENT_FLAG_SYSTEM, "Reload", "Module: Manager\r\nStatus: %s\r\nMessage: Manager reload Requested\r\n", manager_enabled ? "Enabled" : "Disabled");
 
 	ast_tcptls_server_start(&ami_desc);
-	if (ast_ssl_setup(amis_desc.tls_cfg))
+	if (ast_ssl_setup(amis_desc.tls_cfg)) {
 		ast_tcptls_server_start(&amis_desc);
+	}
 	return 0;
 }
 
